<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RegisterInvoiceRequest' => '\\StructType\\RegisterInvoiceRequest',
            'ChangeInvoiceStatusRequest' => '\\StructType\\ChangeInvoiceStatusRequest',
            'DeleteInvoiceRequest' => '\\StructType\\DeleteInvoiceRequest',
            'RegisterInvoiceResponse' => '\\StructType\\RegisterInvoiceResponse',
            'ChangeInvoiceStatusResponse' => '\\StructType\\ChangeInvoiceStatusResponse',
            'DeleteInvoiceResponse' => '\\StructType\\DeleteInvoiceResponse',
            'RegisterWorkRequest' => '\\StructType\\RegisterWorkRequest',
            'ChangeWorkStatusRequest' => '\\StructType\\ChangeWorkStatusRequest',
            'DeleteWorkRequest' => '\\StructType\\DeleteWorkRequest',
            'ChangeWorkStatusResponse' => '\\StructType\\ChangeWorkStatusResponse',
            'DeleteWorkResponse' => '\\StructType\\DeleteWorkResponse',
            'RegisterWorkResponse' => '\\StructType\\RegisterWorkResponse',
            'RegisterPaymentRequest' => '\\StructType\\RegisterPaymentRequest',
            'ChangePaymentStatusRequest' => '\\StructType\\ChangePaymentStatusRequest',
            'DeletePaymentRequest' => '\\StructType\\DeletePaymentRequest',
            'RegisterPaymentResponse' => '\\StructType\\RegisterPaymentResponse',
            'ChangePaymentStatusResponse' => '\\StructType\\ChangePaymentStatusResponse',
            'DeletePaymentResponse' => '\\StructType\\DeletePaymentResponse',
            'InvoiceHeaderType' => '\\StructType\\InvoiceHeaderType',
            'InvoiceDataType' => '\\StructType\\InvoiceDataType',
            'LineSummary' => '\\StructType\\LineSummary',
            'WorkHeaderType' => '\\StructType\\WorkHeaderType',
            'WorkDataType' => '\\StructType\\WorkDataType',
            'PaymentHeaderType' => '\\StructType\\PaymentHeaderType',
            'PaymentDataType' => '\\StructType\\PaymentDataType',
            'InvoiceStatus' => '\\StructType\\InvoiceStatus',
            'WorkStatus' => '\\StructType\\WorkStatus',
            'PaymentStatus' => '\\StructType\\PaymentStatus',
            'NewInvoiceStatusType' => '\\StructType\\NewInvoiceStatusType',
            'NewWorkStatusType' => '\\StructType\\NewWorkStatusType',
            'NewPaymentStatusType' => '\\StructType\\NewPaymentStatusType',
            'SourceDocumentID' => '\\StructType\\SourceDocumentID',
            'OrderReferences' => '\\StructType\\OrderReferences',
            'Tax' => '\\StructType\\Tax',
            'DocumentTotals' => '\\StructType\\DocumentTotals',
            'WithholdingTax' => '\\StructType\\WithholdingTax',
            'DateRangeType' => '\\StructType\\DateRangeType',
            'ListInvoiceDocumentsType' => '\\StructType\\ListInvoiceDocumentsType',
            'ListWorkDocumentsType' => '\\StructType\\ListWorkDocumentsType',
            'ListPaymentDocumentsType' => '\\StructType\\ListPaymentDocumentsType',
            'ResponseType' => '\\StructType\\ResponseType',
            'ChannelType' => '\\StructType\\ChannelType',
        );
    }
}
